# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class CallRoute(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        CallRoute - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'targets': 'list[CallTarget]',
            'timeout_milliseconds': 'int'
        }

        self.attribute_map = {
            'targets': 'targets',
            'timeout_milliseconds': 'timeoutMilliseconds'
        }

        self._targets = None
        self._timeout_milliseconds = None

    @property
    def targets(self):
        """
        Gets the targets of this CallRoute.
        A list of CallTargets to be called when the CallRoute is executed

        :return: The targets of this CallRoute.
        :rtype: list[CallTarget]
        """
        return self._targets

    @targets.setter
    def targets(self, targets):
        """
        Sets the targets of this CallRoute.
        A list of CallTargets to be called when the CallRoute is executed

        :param targets: The targets of this CallRoute.
        :type: list[CallTarget]
        """
        
        self._targets = targets

    @property
    def timeout_milliseconds(self):
        """
        Gets the timeout_milliseconds of this CallRoute.
        The amount of time until the call times out

        :return: The timeout_milliseconds of this CallRoute.
        :rtype: int
        """
        return self._timeout_milliseconds

    @timeout_milliseconds.setter
    def timeout_milliseconds(self, timeout_milliseconds):
        """
        Sets the timeout_milliseconds of this CallRoute.
        The amount of time until the call times out

        :param timeout_milliseconds: The timeout_milliseconds of this CallRoute.
        :type: int
        """
        
        self._timeout_milliseconds = timeout_milliseconds

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

